myblog/models/post.py
from datetime import datetime

from sqlalchemy import Column, Integer, String, DateTime, func, ForeignKey, Text
from sqlalchemy.orm import relationship

from myblog.models.db import db
from myblog.models.post_tag import post_tag


class Post(db.Model):
    __tablename__ = "posts"
    id = Column(Integer, primary_key=True)
    title = Column(String(70), nullable=False, default="", server_default="")
    created_at = Column(DateTime, nullable=False, default=datetime.utcnow, server_default=func.now())
    user_id = Column(Integer, ForeignKey("users.id"), nullable=False)
    body = Column(Text, nullable=False, default="", server_default="")
    description = Column(String(155), nullable=False, default="", server_default="")

    tags = relationship(
        "Tag",
        secondary=post_tag,
        back_populates="posts"
    )
    author = relationship("User", back_populates="posts")

    def __repr__(self):
        return f"{self.title}"

myblog/views/posts.py
from flask import Blueprint, render_template, request, url_for, redirect, flash, g
from sqlalchemy import desc

from werkzeug.exceptions import NotFound, abort

from myblog.models.db import db
from myblog.models.post import Post
from myblog.models.user import User
from myblog.views.auth import login_required

posts_bp = Blueprint('posts_bp', __name__, url_prefix='/posts')


@posts_bp.route('/', endpoint='list')
def posts_list():
    posts = db.session.query(Post). \
        join(User). \
        with_entities(Post.id, Post.title, Post.created_at,
                      Post.description,
                      User.name.label('username')). \
        order_by(desc(Post.created_at)). \
        all()
    return render_template(
        'posts/posts_list.html', posts=posts)


@posts_bp.route('/<int:post_id>/', endpoint='details')
def post_details(post_id):
    post = db.session.query(Post). \
        join(User). \
        with_entities(Post.id, Post.title, Post.created_at,
                      Post.description, Post.body,
                      User.id.label('user_id'),
                      User.name.label('username')). \
        filter(Post.id == post_id). \
        first()
    if post is None:
        raise NotFound(f"Пост #{post_id} не найден!")
    return render_template(
        'posts/post_details.html', post=post)


@posts_bp.route("/create/", methods=("GET", "POST"), endpoint="create")
@login_required
def create_post():
    if request.method == "POST":
        post_title = request.form.get("post-title")
        post_description = request.form.get("post-description")
        post_body = request.form.get("post-body")
        error = None
        if not post_title:
            error = 'Требуется заполнить заголовок поста'
        elif not post_description:
            error = 'Требуется заполнить описание поста.'
        elif not post_body:
            error = 'Требуется заполнить текст поста.'
        if error is None:
            post = Post(
                title=post_title,
                description=post_description,
                body=post_body,
                user_id=g.user.id
            )
            db.session.add(post)
            db.session.flush()

            post_id = post.id

            db.session.commit()
            return redirect(
                url_for("posts_bp.details", post_id=post_id))
        flash(error)
    return render_template("posts/post_create.html")


def get_post(post_id, check_author=True):
    post = db.session.query(Post). \
        join(User). \
        with_entities(Post.id, Post.title,
                      Post.description, Post.body,
                      User.id.label('user_id')). \
        filter(Post.id == post_id). \
        first()
    if post is None:
        raise NotFound(f"Пост #{post_id} не найден!")

    # if post is None:
    #   abort(404, "Post id {0} doesn't exist.".format(post_id))

    if check_author and post.user_id != g.user.id:
        abort(403)
    return post


@posts_bp.route('/<int:post_id>/update/', methods=('GET', 'POST'), endpoint='update')
@login_required
def update(post_id):
    post = get_post(post_id)

    if request.method == 'POST':
        post_title = request.form.get("post-title")
        post_description = request.form.get("post-description")
        post_body = request.form.get("post-body")
        error = None
        if not post_title:
            error = 'Требуется заполнить заголовок поста'
        elif not post_description:
            error = 'Требуется заполнить описание поста.'
        elif not post_body:
            error = 'Требуется заполнить текст поста.'

        if error is not None:
            flash(error)
        else:
            db.session.query(Post).filter(Post.id == post_id). \
                update({
                    Post.title: post_title,
                    Post.description: post_description,
                    Post.body: post_body
                }, synchronize_session=False)
            db.session.commit()
            return redirect(
                url_for("posts_bp.details", post_id=post_id))

    return render_template('posts/post_update.html', post=post)


@posts_bp.route('/<int:post_id>/delete/', methods=('POST',))
@login_required
def delete(post_id):
    get_post(post_id)
    db.session.query(Post).filter(Post.id == post_id). \
        delete(synchronize_session=False)
    db.session.commit()
    return redirect(url_for('posts_bp.list'))

myblog/templates/posts/base.html
{% extends 'layout/default.html' %}

{% block content %}
    <!--====== BLOG STANDARD PART START ======-->

    <div class="blog-standard-area pt-90 pb-120">
        <div class="container">
            {% block container %}{% endblock %}
        </div>
    </div>

    <!--====== BLOG STANDARD PART ENDS ======-->
{% endblock %}

myblog/templates/posts/post_create.html
{% extends 'posts/base.html' %}

{% block title %}Создать новый пост{% endblock %}

{% block container %}
  <h4>Создать новый пост</h4>
  <form method="post" class="my-3">

    <div class="form-group">
      <label for="post-title">Заголовок поста</label>
      <input class="form-control" id="post-title" name="post-title" type="text" required  maxlength="70" placeholder="70 символов">
      <label for="post-description">Краткое описание поста</label>
      <input class="form-control" id="post-description" name="post-description" type="text" required  maxlength="155" placeholder="155 символов">
      <label for="post-body">Текст поста</label>
      <textarea class="form-control" id="post-body" name="post-body" required rows="10"></textarea>
    </div>

    <input class="btn btn-primary btn-block" type="submit" value="Создать">
  </form>
  <a href="{{ url_for('posts_bp.list') }}">Назад к списку постов</a>


{% endblock %}

myblog/templates/posts/post_details.html
{% extends 'posts/base.html' %}

{% block title %}{{ post.title }}{% endblock %}
{% block page_title %}Блог о кореллах{% endblock %}

{% block container %}
<div class="row justify-content-center">
    <div class="col-lg-8">
        <div class="blog-standard">
            <div class="single-blog-standard  mt-30">
                <div class="blog-dteails-content blog-border">
                    <div class="blog-details-top">
                        <h2 class="title">{{ post.title }}</h2>
                        <div class="blog-flex">
                            <div class="blog-left">
                                <p>{{ post.username }}</p>
                                <img src="{{ url_for('static', filename='images/user.png') }}" alt="">
                            </div>
                            <div class="blog-right">
                                {% if g.user['id'] == post['user_id'] %}
                                    <a href="{{ url_for('posts_bp.update', post_id=post['id']) }}"><i class="fal fa-arrow-right"></i>Редактировать</a>
                                {% endif %}
                            </div>
                        </div>
                        <ul>
                            <li><i class="fal fa-eye"></i> 0 просмотров</li>
                            <li><i class="fal fa-calendar-alt"></i>{{ post.created_at.strftime("%d.%m.%Y") }}</li>
                        </ul>
                        <p><img src="{{ url_for('static', filename='images/blog-details-thumb.jpg') }}" alt="blog-details"></p>
                        <p>{{ post.body }}</p>
                    </div>
                    <div class="blog-details-next-prev d-flex justify-content-between pt-45 pb-45">
                        <div class="post-prev">
                            <a href="{{ url_for('posts_bp.list') }}">
                                <span>К списку постов</span>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}

myblog/templates/posts/post_update.html
{% extends 'posts/base.html' %}

{% block title %}Редактировать пост "{{ post['title'] }}"{% endblock %}

{% block container %}
  <h4>Редактировать пост</h4>
  <form method="post" class="my-3">

    <div class="form-group">
      <label for="post-title">Заголовок поста</label>
      <input class="form-control" id="post-title" name="post-title" type="text" value="{{ request.form['title'] or post['title'] }}" required  maxlength="70" placeholder="70 символов">
      <label for="post-description">Краткое описание поста</label>
      <input class="form-control" id="post-description" name="post-description" type="text" value="{{ request.form['description'] or post['description'] }}" required  maxlength="155" placeholder="155 символов">
      <label for="post-body">Текст поста</label>
      <textarea class="form-control" id="post-body" name="post-body" required rows="10">{{ request.form['body'] or post['body'] }}</textarea>
    </div>

    <input class="btn btn-primary btn-block" type="submit" value="Сохранить">
  </form>
  <hr>
  <form action="{{ url_for('posts_bp.delete', post_id=post['id']) }}" method="post">
    <input class="danger" type="submit" value="Удалить" onclick="return confirm('Вы уверены?');">
  </form>
  <a href="{{ url_for('posts_bp.list') }}">Назад к списку постов</a>


{% endblock %}

myblog/templates/posts/posts_list.html
{% extends 'posts/base.html' %}

{% block title %}Главная || Блог о кореллах{% endblock %}
{% block page_title %}Блог о кореллах{% endblock %}

{% block container %}
<div class="row justify-content-center">
    <div class="col-lg-8">
        <div class="blog-standard">
            {% for post in posts %}
            <div class="single-blog-standard mt-30">
                <div class="blog-standard-thumb">
                    <img src="{{ url_for('static', filename='images/blog-1.jpg') }}" alt="blog">
                </div>
                <div class="blog-standard-content">
                    <h2 class="title">{{ post.title }}</h2>
                    <ul>
                        <li><i class="fal fa-eye"></i> 0 просмотров</li>
                        <li><i class="fal fa-calendar-alt"></i>{{ post.created_at.strftime("%d.%m.%Y") }}</li>
                    </ul>
                    <p>{{ post.description }}</p>
                    <div class="blog-flex">
                        <div class="blog-left">
                            <p>{{ post.username }}</p>
                            <img src="{{ url_for('static', filename='images/user.png') }}" alt="">
                        </div>
                        <div class="blog-right">
                            <a href="{{ url_for('posts_bp.details', post_id=post.id) }}"><i class="fal fa-arrow-right"></i>Читать</a>
                        </div>
                    </div>
                </div>
            </div>
            {% endfor %}
            {% if not posts %}
            Постов нет
            {% endif %}
        </div>
        <div class="row">
            <div class="col-lg-12">
                <div class="pagination-area d-flex justify-content-center mt-40">
                    <nav aria-label="Page navigation example">
                        <ul class="pagination">
                            <li class="page-item">
                                <a class="page-link" href="#" aria-label="Previous">
                                    <span aria-hidden="true">&laquo;</span>
                                </a>
                            </li>
                            <li class="page-item"><a class="page-link" href="#">1</a></li>
                            <li class="page-item"><a class="page-link" href="#">2</a></li>
                            <li class="page-item"><a class="page-link" href="#">3</a></li>
                            <li class="page-item"><a class="page-link" href="#">...</a></li>
                            <li class="page-item"><a class="page-link" href="#">10</a></li>
                            <li class="page-item">
                                <a class="page-link" href="#" aria-label="Next">
                                    <span aria-hidden="true">&raquo;</span>
                                </a>
                            </li>
                        </ul>
                    </nav>
                </div>
            </div>
        </div>
    </div>
</div>
{% endblock %}